---
// Import layouts
import Layout from "@layouts/Layout.astro";

// Import images
import workingIconImg from "@assets/img/feature-matrix/working.svg";
import notWorkingIconImg from "@assets/img/feature-matrix/not-working.svg";

// Import data
import getDevices from "@logic/build/getDevices.js";

// Export pages list
export async function getStaticPaths() {
  const devices = await getDevices("get-all-devices");
  return devices.map((device) => {
    return {
      params: {
        codename: device.releases.current.deviceParam
      },
      props: {
        device: device
      }
    };
  });
}

// Get current device
const { device } = Astro.props;

const pageMeta = {
  title: device.name + " • Missing data • Ubuntu Touch",
  meta: [
    {
      name: "description",
      content:
        "Read the developer report for " +
        device.name +
        " with the Ubuntu Touch operating system."
    },
    {
      property: "og:url",
      content: "https://devices.ubuntu-touch.io" + device.path + "/developer"
    },
    {
      property: "og:title",
      content: device.name + " • Developer report"
    },
    {
      property: "og:description",
      content:
        "Read the developer report for " +
        device.name +
        " with the Ubuntu Touch operating system."
    }
  ]
};
---

<Layout pageMeta={pageMeta}>
  <!-- Heading -->
  <h1 class="h3 mt-lg-5">Dear Ubuntu Contributors</h1>
  <p class="mt-3 h6">
    The entire UBports community relies on these pages. Unfortunately, the
    correlation between porter’s work and the software capability list is a
    manual process. Therefore, we would appreciate it if you could help improve
    this website. Newcomers will benefit from your work!
  </p>

  <p class="mt-3">
    Due to the natural characteristics of open source, information tends to be
    spread across and wide range of resources, and it can be a challenge to
    track everything down.
  </p>

  <p class="mt-3">
    We encourage porters to bring everything together in one place and to keep
    the most relevant links for their devices up-to-date.
  </p>

  <p class="mt-3">
    The list of properties that a device page can present may vary over time.
    However, the porters provide the mandatory information to establish a page
    with at least the essential info.
  </p>

  {
    device.notValid.length > 0 && (
      <div>
        <h2 class="h4 light mt-5">How can you help?</h2>

        <p class="mt-2">
          We noticed
          <a
            class="text-orange bold underline"
            target="_blank"
            href={
              "https://gitlab.com/ubports/infrastructure/devices.ubuntu-touch.io/-/blob/main/data/devices/" +
              device.codename +
              "/data.md"
            }
          >
            {device.name} page
          </a>
          has few missing properties from the last report
        </p>

        <ul class="mt-2 missing-data-list">
          {device.notValid.map((error) => (
            <li>{error.instancePath + " " + error.message}</li>
          ))}
        </ul>
      </div>
    )
  }

  <p class="mt-3">Use these guidelines to fill the missing parts</p>
  <p>
    <a href="/about/device-file#device-description" class="link"
      >Device description</a
    >
    |
    <a href="/about/device-file#contributors" class="link">Contributors</a>
    |
    <a href="/about/device-file#yaml-metadata-block-reference" class="link"
      >Meta Data</a
    >
    |
    <a href="/about/device-file#device-specifications" class="link"
      >Device Info (Specifications)</a
    >
  </p>

  <a
    class="btn mt-4 btn-primary"
    target="_blank"
    href={"https://gitlab.com/ubports/infrastructure/devices.ubuntu-touch.io/-/blob/main/data/devices/" +
      device.codename +
      "/data.md"}>Start editing</a
  >

  <h2 class="h4 light mt-5">Autodetection status</h2>

  <p class="mt-4">
    Some features are automatically detected from codename and other properties,
    you can check if your device was detected correctly below:
  </p>
  <ul>
    {
      device.autodetectionHints.map((feature) => (
        <li>
          <p class="bold mt-3">
            <img
              class="d-inline me-2"
              src={feature.success ? workingIconImg.src : notWorkingIconImg.src}
            />
            {feature.source}
          </p>
          <p class="ms-4 mt-2">{feature.status}</p>
          {feature.logs && (
            <code class="code ms-4 mt-2">
              <pre class="mb-0">{feature.logs}</pre>
            </code>
          )}
        </li>
      ))
    }
  </ul>

  <div class="mt-5 banner-grey">
    <p>Another way you can help</p>
    <h3 class="h4 mt-3 light">→ Gather information</h3>

    <p class="mt-3">
      Did you come across a useful source for information that helped you over
      come issue? Then we ask you to share it with us! submit it as an
      <a
        href="/about/device-file#external-links-community-help-and-doc-links"
        class="link">External Link</a
      >
    </p>
  </div>
</Layout>
